#include <cstdlib>
#include <iostream>

using namespace std;

char origfile[255] = "deepj.fds";
char expandfile[255] = "deep_exp.fds";
char direct[255] = "expand.txt";

unsigned int checksize(int disk, int fileID);   //check to see if a file should be expanded
unsigned long int hexint(char str[]);           //convert a string to int

int main()
{
    char string[260];  //a junk string
    unsigned char readbyte;
    bool read_header=0;
    bool write_header=0;
    unsigned long int oldfpos=0;      //position in original file
    unsigned long int newfpos=0;      //position in expansion file.
    unsigned long int endfpos=0;
    unsigned int newsize=0;
    unsigned int oldsize=0;
    int diskdo=1;
    int filedo=0;
    int files_left=0;
    int disks_left;
    int add_header=1;
    cout<<"FDS Image Expander. (c)2006 KingMike Translations\n";
    cout<<"Original game file:";
    cin>>origfile;
    cout<<"Expand copy of game file as:";
    cin>>expandfile;
    cout<<"List of files to be expanded:";
    cin>>direct;
    cout<<"Add .fds header if not on original (1=yes, anything else=no)?";
    cin>>add_header;
    FILE *src = fopen(origfile,"rb");
    if(src == NULL)
    {
        cout<<"Can't open file "<<origfile<<"\n";
        system("PAUSE");
        return EXIT_FAILURE;
    }
    FILE *exp = fopen(expandfile,"wb");
    if(exp == NULL)                //expanded gamefile
    {
        cout<<"Can't open file "<<expandfile<<"\n";
        system("PAUSE");
        return EXIT_FAILURE;
    }
    fseek(src,0,SEEK_END);
    endfpos=ftell(src);
    disks_left=(endfpos-16)/0xFFDC;
    disks_left++;
    fseek(src,oldfpos,SEEK_SET);
    readbyte=fgetc(src);
    if(readbyte=='F')
    {
        oldfpos+=16;    //FDS header
        read_header=1;
    }
    if(read_header==1 || add_header==1)
    {
        fseek(exp,0,SEEK_SET);
        fputc((char)'F',exp);
        fputc((char)'D',exp);
        fputc((char)'S',exp);
        fputc((char)0x1A,exp);
        fputc((char)disks_left,exp);
        for(int x=0;x<11;x++)
            fputc((char)0,exp);
        newfpos+=16;
        write_header=1;
    } 
    while(disks_left>0)
    {
        filedo=0;
        fseek(src,((diskdo-1)*0xFFDC)+(read_header*0x10)+0x39,SEEK_SET);
        readbyte=fgetc(src);
        files_left=readbyte;
        for(int x=0; x<=0x39;x++)  //copy disk side header
        {
            fseek(src,oldfpos,SEEK_SET);
            readbyte=fgetc(src);
            fseek(exp,newfpos,SEEK_SET);
            fputc(readbyte,exp);
            oldfpos++;
            newfpos++;
        }
        while(files_left>0)
        {
            newsize=checksize(diskdo,filedo);
            for(int x=0;x<0x0D;x++)
            {
                 fseek(src,oldfpos,SEEK_SET);
                 readbyte=fgetc(src);
                 fseek(exp,newfpos,SEEK_SET);
                 fputc(readbyte,exp);
                 oldfpos++;
                 newfpos++;
                 //get: 0x03, file #, file ID, file name, RAM offset
            }
            fseek(src,oldfpos,SEEK_SET);
            readbyte=fgetc(src);
            oldsize=readbyte;
            readbyte=fgetc(src);
            oldsize=oldsize+(readbyte*0x100);
            if(newsize==0x7FFF)
            {
                newsize=oldsize;
            }
            readbyte=newsize&0xFF;
            fseek(exp,newfpos,SEEK_SET);
            fputc(readbyte,exp);             //write file size
            readbyte=(newsize&0xFF00)>>8;
	        newfpos++;
            fseek(exp,newfpos,SEEK_SET);
            fputc(readbyte,exp);
            oldfpos+=2;
            newfpos++;
            fseek(src,oldfpos,SEEK_SET);
            readbyte=fgetc(src);        //RAM type
            fseek(src,newfpos,SEEK_SET);
            fputc(readbyte,exp);
            readbyte=fgetc(src);        //0x04
            fputc(readbyte,exp);
            oldfpos+=2;
            newfpos+=2;
            //write file
            for(int x=0; x<oldsize;x++)
            {
                fseek(src,oldfpos,SEEK_SET);
                readbyte=fgetc(src);
                fseek(exp,newfpos,SEEK_SET);
                fputc(readbyte,exp);
                oldfpos++;
                newfpos++;
            }
            while(oldsize<newsize)  //print 0s for the extra space.
            {
                fseek(exp,newfpos,SEEK_SET);
                fputc((char)0x00,exp);
                newfpos++;
                oldsize++;
            }
            filedo++;
            files_left--;
        }//done one file
    oldfpos++;
    newfpos++;
    //now fill the rest of the disk side with 0s.
    while(newfpos<((diskdo)*0xFFDC)+(write_header*0x10))
    {
        fseek(exp,newfpos,SEEK_SET);
        fputc((char)0x00,exp);
        oldfpos++;
        newfpos++;
    }
    oldfpos=(diskdo*0xFFDC)+(read_header*0x10);
    diskdo++;
    disks_left--;
    }//done one disk
    cout<<"Original game expanded.\n";
    system("PAUSE");
}

unsigned int checksize(int disk, int fileID)
{
    FILE *dir = fopen(direct,"rb");
    if(dir == NULL)                //expansion directions
    {
        cout<<"Can't open file "<<origfile<<"\n";
        system("PAUSE");
        return EXIT_FAILURE;
    }
    unsigned int dp=0;     //directions pointer
    char str[30];
    int diskfound=8;       //didn't find a disk yet
    int filefound=99;
    unsigned char readbyte;
    bool searchdisk = 1;         //keep searching for a disk
    bool searchfile = 1;
    int size=0x7FFF;
    fseek(dir,dp,SEEK_SET);
    readbyte=fgetc(dir);
    while(searchdisk==1)
    {
        dp++;
        fseek(dir,dp,SEEK_SET);
        readbyte=fgetc(dir);    //get disk side.
        diskfound=readbyte-'0';
        if(diskfound==disk)
        {
            searchdisk=0;
        }//desired disk found
        else if(diskfound==9)
        {//desired disk not found
            searchdisk=0;
        }//end of disk found
        else
        {
            dp++;
            fseek(dir,dp,SEEK_SET);
            readbyte=fgetc(dir);
            while(readbyte!=';')
            {
                dp++;
                fseek(dir,dp,SEEK_SET);
                readbyte=fgetc(dir);
            }
        }//loop to next disk
    }
    if(diskfound==disk)
    {
        while(searchfile==1)
        {
            dp++;
            fseek(dir,dp,SEEK_SET);
            readbyte=fgetc(dir);
            while(readbyte!=0x0D)
            {
                dp++;
                fseek(dir,dp,SEEK_SET);
                readbyte=fgetc(dir);
            }
            dp+=2;
            //now, get the file ID
            fseek(dir,dp,SEEK_SET);
            readbyte=fgetc(dir);
            if(readbyte==';')
            {
                searchfile=0;
            }
            else
            {
                fseek(dir,dp,SEEK_SET);
                readbyte=fgetc(dir);
                int x=0;
                while(readbyte!=',')
                {
                    fseek(dir,dp,SEEK_SET);
                    str[x]=readbyte=fgetc(dir);
                    dp++;
                    x++;
                }
                str[--x]='\0';
                filefound=hexint(str);
            }//while we found a file entry
            if(filefound==fileID && searchfile==1)
            {//found desired file
                fseek(dir,dp,SEEK_SET);
                readbyte=fgetc(dir);
                int x=0;
                while(readbyte!=0x0D)
                {
                    fseek(dir,dp,SEEK_SET);
                    str[x]=readbyte=fgetc(dir);
                    dp++;
                    x++;
                }
                str[--x]='\0';
                size=hexint(str);
                searchfile=0;
            }
        }//searching entries
    }//now do something with the disk found
    fclose(dir);
    return size;
}

unsigned long int hexint(char str[])
{
    unsigned long int total = 0;
    int x = 0;
    int val;
    while(str[x]!='\0')
    {
        if(str[x]>='0' && str[x]<='9')
            val=str[x]-'0';
        else if(str[x]>='A' && str[x]<='F')
            val=str[x]-'A'+10;
        else if(str[x]>='a' && str[x]<='f')
            val=str[x]-'a'+10;
        total=(total<<4) + val;
        x++;
    }
    return total;
}
